{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/biobambam:533ed9be5fd34b177b5a906262c615bff1a4cdc2c84b78c2244cbd7283842120"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 2000,
                    "ramMax": 2000,
                    "tmpdirMin": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "tmpdirMax": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "outdirMin": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "outdirMax": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#biobambam2_bamtofastq.cwl/collate",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "collate=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/exclude",
                    "type": "string",
                    "default": "QCFAIL,SECONDARY,SUPPLEMENTARY",
                    "inputBinding": {
                        "prefix": "exclude=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/filename",
                    "format": "#biobambam2_bamtofastq.cwl/format_2572",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "filename=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/gz",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "gz=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/inputformat",
                    "type": "string",
                    "default": "bam",
                    "inputBinding": {
                        "prefix": "inputformat=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/level",
                    "type": "int",
                    "default": 5,
                    "inputBinding": {
                        "prefix": "level=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputdir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "outputdir=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroup",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "outputperreadgroup=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixF",
                    "type": "string",
                    "default": "_1.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixF=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixF2",
                    "type": "string",
                    "default": "_2.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixF2=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixO",
                    "type": "string",
                    "default": "_o1.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixO=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixO2",
                    "type": "string",
                    "default": "_o2.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixO2=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixS",
                    "type": "string",
                    "default": "_s.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixS=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/tryoq",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "tryoq=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/T",
                    "type": "string",
                    "default": "tempfq",
                    "inputBinding": {
                        "prefix": "T=",
                        "separate": false
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bamtofastq"
            ],
            "id": "#biobambam2_bamtofastq.cwl",
            "outputs": [
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq1",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq2",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_o1",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_o1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_o2",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_o2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_s",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_s.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "name": "#readgroup.yml/readgroup_meta",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_meta/CN",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DT",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/FO",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/ID",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/KS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/LB",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PI",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PL",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PM",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PU",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/SM",
                                    "type": "string"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/forward_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/reverse_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/bam",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#emit_readgroup_fastq_pe_files.cwl/forward_fastq_list",
                    "format": "#emit_readgroup_fastq_pe_files.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#emit_readgroup_fastq_pe_files.cwl/reverse_fastq_list",
                    "format": "#emit_readgroup_fastq_pe_files.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#emit_readgroup_fastq_pe_files.cwl/readgroup_meta_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_meta"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#emit_readgroup_fastq_pe_files.cwl/output",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_pe_file"
                    }
                }
            ],
            "expression": "${\n    // https://stackoverflow.com/a/9849276/810957\n    function include(arr,obj) {\n      return (arr.indexOf(obj) != -1)\n    }\n\n    // https://stackoverflow.com/a/2548133/810957\n    function endsWith(str, suffix) {\n      return str.indexOf(suffix, str.length - suffix.length) !== -1;\n    }\n\n    // https://stackoverflow.com/questions/3820381/need-a-basename-function-in-javascript#comment29942319_15270931\n    function local_basename(path) {\n      var basename = path.split(/[\\\\/]/).pop();\n      return basename\n    }\n\n    function get_slice_number(fastq_name) {\n      if (endsWith(fastq_name, '_1.fq.gz')) {\n        return -8\n      }\n      else if (endsWith(fastq_name, '_s.fq.gz')) {\n        return -8\n      }\n      else if (endsWith(fastq_name, '_o1.fq.gz')) {\n        return -9\n      }\n      else if (endsWith(fastq_name, '_o2.fq.gz')) {\n        return -9\n      }\n      else {\n        throw \"not recognized fastq suffix\"\n      }\n    }\n\n  // get readgroup name from fastq\n  function fastq_to_rg_id(fq_file_object) {\n    var fastq_name = local_basename(fq_file_object.location);\n    var slice_number = get_slice_number(fastq_name);\n    var readgroup_name = fastq_name.slice(0,slice_number);\n    return readgroup_name;\n  }\n\n  // get predicted readgroup names from fastq\n  var readgroup_name_array = [];\n  for (var i = 0; i < inputs.forward_fastq_list.length; i++) {\n    var fq = inputs.forward_fastq_list[i];\n    var readgroup_name = fastq_to_rg_id(fq);\n    readgroup_name_array.push(readgroup_name);\n  }\n\n  var actual_readgroup_name_array = [];\n  for (var i = 0; i < inputs.readgroup_meta_list.length; i++) {\n    var actual_readgroup_name = inputs.readgroup_meta_list[i][\"ID\"];\n    actual_readgroup_name_array.push(actual_readgroup_name);\n  }\n  \n  // ensure predicted readgroup names are in actual list\n  for (var i = 0; i < readgroup_name_array.length; i++) {\n    var pred_readgroup_name = readgroup_name_array[i];\n    if (!(include(actual_readgroup_name_array, pred_readgroup_name))) {\n      throw \"not recognized pred_readgroup_name\"\n    }\n  }\n\n  // build output\n  var output_array = [];\n  for (var i = 0; i < inputs.forward_fastq_list.length; i++) {\n    var forward_fastq = inputs.forward_fastq_list[i];\n    var reverse_fastq = inputs.reverse_fastq_list[i];\n    var readgroup_name = fastq_to_rg_id(forward_fastq);\n    for (var j = 0; j < inputs.readgroup_meta_list.length; j++) {\n      var readgroup_id = inputs.readgroup_meta_list[j][\"ID\"];\n      if (readgroup_name === readgroup_id) {\n        var readgroup_meta = inputs.readgroup_meta_list[j];\n        break;\n      }\n    }\n\n    var output = {\"forward_fastq\": forward_fastq,\n                  \"reverse_fastq\": reverse_fastq,\n                  \"readgroup_meta\": readgroup_meta};\n    output.forward_fastq.format = \"edam:format_2182\";\n    output.reverse_fastq.format = \"edam:format_2182\";\n    output_array.push(output);\n  }\n  \n  return {'output': output_array}\n}\n",
            "id": "#emit_readgroup_fastq_pe_files.cwl"
        },
        {
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#emit_readgroup_fastq_se_files.cwl/fastq_list",
                    "format": "#emit_readgroup_fastq_se_files.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#emit_readgroup_fastq_se_files.cwl/readgroup_meta_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_meta"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#emit_readgroup_fastq_se_files.cwl/output",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_se_file"
                    }
                }
            ],
            "expression": "${\n    // https://stackoverflow.com/a/9849276/810957\n    function include(arr,obj) {\n      return (arr.indexOf(obj) != -1)\n    }\n\n    // https://stackoverflow.com/a/2548133/810957\n    function endsWith(str, suffix) {\n      return str.indexOf(suffix, str.length - suffix.length) !== -1;\n    }\n\n    // https://stackoverflow.com/questions/3820381/need-a-basename-function-in-javascript#comment29942319_15270931\n    function local_basename(path) {\n      var basename = path.split(/[\\\\/]/).pop();\n      return basename\n    }\n\n    function get_slice_number(fastq_name) {\n      if (endsWith(fastq_name, '_1.fq.gz')) {\n        return -8\n      }\n      else if (endsWith(fastq_name, '_s.fq.gz')) {\n        return -8\n      }\n      else if (endsWith(fastq_name, '_o1.fq.gz')) {\n        return -9\n      }\n      else if (endsWith(fastq_name, '_o2.fq.gz')) {\n        return -9\n      }\n      else {\n        throw \"not recognized fastq suffix\"\n      }\n    }\n\n  // get readgroup name from fastq\n  function fastq_to_rg_id(fq_file_object) {\n    var fastq_name = local_basename(fq_file_object.location);\n    var slice_number = get_slice_number(fastq_name);\n    var readgroup_name = fastq_name.slice(0,slice_number);\n    return readgroup_name;\n  }\n\n  // get predicted readgroup names from fastq\n  var readgroup_name_array = [];\n  for (var i = 0; i < inputs.fastq_list.length; i++) {\n    var fq = inputs.fastq_list[i];\n    var readgroup_name = fastq_to_rg_id(fq);\n    readgroup_name_array.push(readgroup_name);\n  }\n\n  var actual_readgroup_name_array = [];\n  for (var i = 0; i < inputs.readgroup_meta_list.length; i++) {\n    var actual_readgroup_name = inputs.readgroup_meta_list[i][\"ID\"];\n    actual_readgroup_name_array.push(actual_readgroup_name);\n  }\n  \n  // ensure predicted readgroup names are in actual list\n  for (var i = 0; i < readgroup_name_array.length; i++) {\n    var pred_readgroup_name = readgroup_name_array[i];\n    if (!(include(actual_readgroup_name_array, pred_readgroup_name))) {\n      throw \"not recognized pred_readgroup_name\"\n    }\n  }\n\n  // build output\n  var output_array = [];\n  for (var i = 0; i < inputs.fastq_list.length; i++) {\n    var fastq = inputs.fastq_list[i];\n    var readgroup_name = fastq_to_rg_id(fastq);\n    for (var j = 0; j < inputs.readgroup_meta_list.length; j++) {\n      var readgroup_id = inputs.readgroup_meta_list[j][\"ID\"];\n      if (readgroup_name === readgroup_id) {\n        var readgroup_meta = inputs.readgroup_meta_list[j];\n        break;\n      }\n    }\n    var output = {\"fastq\": fastq,\n                  \"readgroup_meta\": readgroup_meta};\n    output.fastq.format = \"edam:format_2182\";\n    output_array.push(output);\n  }\n  \n  return {'output': output_array}\n}\n",
            "id": "#emit_readgroup_fastq_se_files.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/readgroups_bam_file",
                    "type": "#readgroup.yml/readgroups_bam_file"
                }
            ],
            "outputs": [
                {
                    "id": "#main/pe_file_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_pe_file"
                    },
                    "outputSource": "#main/emit_readgroup_pe_files/output"
                },
                {
                    "id": "#main/se_file_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_se_file"
                    },
                    "outputSource": "#main/emit_readgroup_se_files/output"
                },
                {
                    "id": "#main/o1_file_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_se_file"
                    },
                    "outputSource": "#main/emit_readgroup_o1_files/output"
                },
                {
                    "id": "#main/o2_file_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_se_file"
                    },
                    "outputSource": "#main/emit_readgroup_o2_files/output"
                }
            ],
            "steps": [
                {
                    "id": "#main/biobambam_bamtofastq",
                    "run": "#biobambam2_bamtofastq.cwl",
                    "in": [
                        {
                            "id": "#main/biobambam_bamtofastq/filename",
                            "source": "#main/readgroups_bam_file",
                            "valueFrom": "$(self.bam)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq2"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_o1"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_o2"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_s"
                        }
                    ]
                },
                {
                    "id": "#main/emit_readgroup_pe_files",
                    "run": "#emit_readgroup_fastq_pe_files.cwl",
                    "in": [
                        {
                            "id": "#main/emit_readgroup_pe_files/forward_fastq_list",
                            "source": "#main/biobambam_bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#main/emit_readgroup_pe_files/reverse_fastq_list",
                            "source": "#main/biobambam_bamtofastq/output_fastq2"
                        },
                        {
                            "id": "#main/emit_readgroup_pe_files/readgroup_meta_list",
                            "source": "#main/readgroups_bam_file",
                            "valueFrom": "$(self.readgroup_meta_list)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/emit_readgroup_pe_files/output"
                        }
                    ]
                },
                {
                    "id": "#main/emit_readgroup_se_files",
                    "run": "#emit_readgroup_fastq_se_files.cwl",
                    "in": [
                        {
                            "id": "#main/emit_readgroup_se_files/fastq_list",
                            "source": "#main/biobambam_bamtofastq/output_fastq_s"
                        },
                        {
                            "id": "#main/emit_readgroup_se_files/readgroup_meta_list",
                            "source": "#main/readgroups_bam_file",
                            "valueFrom": "$(self.readgroup_meta_list)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/emit_readgroup_se_files/output"
                        }
                    ]
                },
                {
                    "id": "#main/emit_readgroup_o1_files",
                    "run": "#emit_readgroup_fastq_se_files.cwl",
                    "in": [
                        {
                            "id": "#main/emit_readgroup_o1_files/fastq_list",
                            "source": "#main/biobambam_bamtofastq/output_fastq_o1"
                        },
                        {
                            "id": "#main/emit_readgroup_o1_files/readgroup_meta_list",
                            "source": "#main/readgroups_bam_file",
                            "valueFrom": "$(self.readgroup_meta_list)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/emit_readgroup_o1_files/output"
                        }
                    ]
                },
                {
                    "id": "#main/emit_readgroup_o2_files",
                    "run": "#emit_readgroup_fastq_se_files.cwl",
                    "in": [
                        {
                            "id": "#main/emit_readgroup_o2_files/fastq_list",
                            "source": "#main/biobambam_bamtofastq/output_fastq_o2"
                        },
                        {
                            "id": "#main/emit_readgroup_o2_files/readgroup_meta_list",
                            "source": "#main/readgroups_bam_file",
                            "valueFrom": "$(self.readgroup_meta_list)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/emit_readgroup_o2_files/output"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
